/* ARCADEmini assembler (unix)
 * version 1.4 date 2004-03-15
 * part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
 * Copyright (C) 2003-2004 1stein <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

%{
#include "node.h"
#include "debug.h"
#include "parse_.h"
#include "scan.h"
#include "global.h"

//some special flags for "CP_BLK"
unsigned char cp_blk_flags = 0;

//parser state
st_node * p_cur_reg = &node_reg_none; //pointer to current register
unsigned long cur_addr_sec = 0; //sector part of current address
unsigned short cur_addr_ofs = 0; //offset part of current address

//lexer function
int yylex( );

//error function
int yyerror( );

//functions to create nodes for (register-)commands
static inline st_node * cmd_register( st_node * p_con );
static inline st_node * cmd_next_register( );
static inline st_node * cmd_empty( );
static inline st_node * cmd_next_sector( );
static inline st_node * cmd_new_0( unsigned char code );
static inline st_node * cmd_new_1( unsigned char code, st_node * p_param1 );
static inline st_node * cmd_new_2( unsigned char code, st_node * p_param1, st_node * p_param2 );
static inline st_node * cmd_new_3( unsigned char code, st_node * p_param1, st_node * p_param2, st_node * p_param3 );
static inline st_node * cmd_new_4( unsigned char code, st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4 );
static inline st_node * cmd_new_5( unsigned char code, st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5 );
static inline st_node * cmd_new_6( unsigned char code, st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5, st_node * p_param6 );
static inline st_node * cmd_new_9( unsigned char code,
                                   st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5,
                                   st_node * p_param6, st_node * p_param7, st_node * p_param8, st_node * p_param9 );
static inline st_node * cmd_new_14( unsigned char code,
                                    st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5, st_node * p_param6, st_node * p_param7,
                                    st_node * p_param8, st_node * p_param9, st_node * p_param10, st_node * p_param11, st_node * p_param12, st_node * p_param13, st_node * p_param14 );
static inline st_node * cmd_new_65( unsigned char code,
                                    st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5,
				    st_node * p_param6, st_node * p_param7, st_node * p_param8, st_node * p_param9, st_node * p_param10,
				    st_node * p_param11, st_node * p_param12, st_node * p_param13, st_node * p_param14, st_node * p_param15,
				    st_node * p_param16, st_node * p_param17, st_node * p_param18, st_node * p_param19, st_node * p_param20,
				    st_node * p_param21, st_node * p_param22, st_node * p_param23, st_node * p_param24, st_node * p_param25,
				    st_node * p_param26, st_node * p_param27, st_node * p_param28, st_node * p_param29, st_node * p_param30,
				    st_node * p_param31, st_node * p_param32, st_node * p_param33, st_node * p_param34, st_node * p_param35,
				    st_node * p_param36, st_node * p_param37, st_node * p_param38, st_node * p_param39, st_node * p_param40,
				    st_node * p_param41, st_node * p_param42, st_node * p_param43, st_node * p_param44, st_node * p_param45,
				    st_node * p_param46, st_node * p_param47, st_node * p_param48, st_node * p_param49, st_node * p_param50,
				    st_node * p_param51, st_node * p_param52, st_node * p_param53, st_node * p_param54, st_node * p_param55,
				    st_node * p_param56, st_node * p_param57, st_node * p_param58, st_node * p_param59, st_node * p_param60,
				    st_node * p_param61, st_node * p_param62, st_node * p_param63, st_node * p_param64, st_node * p_param65 );
static inline st_node * cmd_new_66( unsigned char code,
                                    st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5,
				    st_node * p_param6, st_node * p_param7, st_node * p_param8, st_node * p_param9, st_node * p_param10,
				    st_node * p_param11, st_node * p_param12, st_node * p_param13, st_node * p_param14, st_node * p_param15,
				    st_node * p_param16, st_node * p_param17, st_node * p_param18, st_node * p_param19, st_node * p_param20,
				    st_node * p_param21, st_node * p_param22, st_node * p_param23, st_node * p_param24, st_node * p_param25,
				    st_node * p_param26, st_node * p_param27, st_node * p_param28, st_node * p_param29, st_node * p_param30,
				    st_node * p_param31, st_node * p_param32, st_node * p_param33, st_node * p_param34, st_node * p_param35,
				    st_node * p_param36, st_node * p_param37, st_node * p_param38, st_node * p_param39, st_node * p_param40,
				    st_node * p_param41, st_node * p_param42, st_node * p_param43, st_node * p_param44, st_node * p_param45,
				    st_node * p_param46, st_node * p_param47, st_node * p_param48, st_node * p_param49, st_node * p_param50,
				    st_node * p_param51, st_node * p_param52, st_node * p_param53, st_node * p_param54, st_node * p_param55,
				    st_node * p_param56, st_node * p_param57, st_node * p_param58, st_node * p_param59, st_node * p_param60,
				    st_node * p_param61, st_node * p_param62, st_node * p_param63, st_node * p_param64, st_node * p_param65,
				    st_node * p_param66 );
static inline st_node * cmd_new_7b9b_0( unsigned char code7b, st_node * p_param9b );
static inline st_node * cmd_new_7b9b_2( unsigned char code7b, st_node * p_param9b, st_node * p_param1, st_node * p_param2 );
static inline st_node * cmd_new_8b16b_0( unsigned char code8b, st_node * p_param16b );
static inline st_node * cmd_new_8b32b_0( unsigned char code8b, st_node * p_param32b );
static inline st_node * cmd_new_7b9b32b_0( unsigned char code7b, st_node * p_param9b, st_node * p_param32b );
static inline st_node * cmd_new_7b41b_0( unsigned char code7b, st_node * p_param41b );
static inline st_node * cmd_new_code2_6( unsigned char code, unsigned char code2, st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5, st_node * p_param6 );
static inline st_node * cmd_new_code2_7( unsigned char code, unsigned char code2, st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5, st_node * p_param6, st_node * p_param7 );
static inline st_node * cmd_new_8b( st_node * p_param8b );
static inline st_node * cmd_new_16b( st_node * p_param16b );
static inline st_node * cmd_new_32b( st_node * p_param32b );
static inline st_node * cmd_new_str( st_node * p_str );

//put pointer to declaration node into id_list
static inline st_id_list_entry * lab_decl( st_node * p_lab_node, st_node * p_decl_node );
%}

%token CMD_REGISTER CMD_NEXT_REG CMD_NEXT_SEC
%token CMD_DB CMD_DW CMD_DD
%token CMD_JMP_NEXT_SEC CMD_JMP_SEC CMD_JMP_OFS CMD_JMP_OFS_SEC CMD_JMP_IND
%token CMD_JMP_EQ CMD_JMP_NEQ
%token CMD_JMP_GT CMD_JMP_NGT CMD_JMP_LT CMD_JMP_NLT
%token CMD_JMP_GTS CMD_JMP_NGTS CMD_JMP_LTS CMD_JMP_NLTS
%token CMD_JMP_AND_Z CMD_JMP_AND_NZ CMD_JMP_OR_M CMD_JMP_OR_NM
%token CMD_MOV CMD_MOV2 CMD_MOV4
%token CMD_RD_I CMD_WR_I CMD_RD_S CMD_RD_CF
%token CMD_ADD CMD_ADDC CMD_SUB CMD_SUBB
%token CMD_MUL CMD_MULS CMD_DIV CMD_DIVS
%token CMD_AND CMD_OR CMD_XOR
%token CMD_SHL CMD_SHR CMD_ROL CMD_ROR
%token CMD_PUSH CMD_PUSH_C CMD_POP CMD_CALL CMD_CALL_IND CMD_RET
%token CMD_RD_PIX CMD_RD_OVP CMD_WR_PIX CMD_WR_OVP
%token CMD_WR_PIX_LINE CMD_WR_OVP_LINE CMD_WR_PIX_QUART CMD_WR_OVP_QUART
%token CMD_WR_PIX_CLR CMD_WR_OVP_CLR CMD_WR_PIX_SET CMD_WR_OVP_SET
%token CMD_WR_PIX_BW CMD_WR_OVP_BW CMD_WR_PIX_SEL CMD_WR_OVP_SEL
%token CMD_CP_BLK_PP CMD_CP_BLK_PO CMD_CP_BLK_OP CMD_CP_BLK_OO
%token CMD_CP_BLK_PP_TR CMD_CP_BLK_PO_TR CMD_CP_BLK_OP_TR CMD_CP_BLK_OO_TR
%token CMD_DISPLAY CMD_DISPLAY_CP
%token CMD_DELAY_DO CMD_DELAY_START CMD_DELAY_CHECK CMD_DELAY_WAIT
%token CMD_GET_KEYS CMD_GET_SNES0 CMD_GET_SNES1
%token CMD_GET_TIME CMD_SET_TIME
%token CMD_RND CMD_VER
%token CMD_NOP

%token LABEL_CON IDENT_CON
%token LABEL_REG IDENT_REG
%token LABEL_ADDR IDENT_ADDR

%token NUMBER CHAR STRING

%token LBRA RBRA
%right NOT
%left MUL DIV MOD
%left ADD SUB
%left SHL SHR
%left AND
%left XOR
%left OR

%right SEC OFS
%right REG
%token COMMA
%token SEM

%token COMMENT

%token UNKNOWN

%union
{
  st_node * p_node;
}

%type <p_node> LABEL_CON
%type <p_node> LABEL_REG
%type <p_node> LABEL_ADDR
%type <p_node> NUMBER
%type <p_node> CHAR
%type <p_node> STRING
%type <p_node> IDENT_CON
%type <p_node> IDENT_REG
%type <p_node> IDENT_ADDR

%type <p_node> list;
%type <p_node> lab_con;
%type <p_node> lab_reg;
%type <p_node> lab_cmd;
%type <p_node> reg_cmd;
%type <p_node> cmd;
%type <p_node> cp_blk_prm;
%type <p_node> reg;
%type <p_node> reg_solid;
%type <p_node> sec;
%type <p_node> ofs;
%type <p_node> con;
%type <p_node> con_or;
%type <p_node> con_xor;
%type <p_node> con_and;
%type <p_node> con_sh;
%type <p_node> con_add;
%type <p_node> con_mul;
%type <p_node> con_unary;
%type <p_node> con_solid;
%type <p_node> addr;

%%

start: list { p_list = $1; debug( "RULE: start -> list" ); }
     ;

list: { $$ = NULL; debug( "RULE: list ->" ); }
    | lab_con list { $$ = node_new_list( $1, $2 ); debug( "RULE: list -> lab_con list" ); }
    | lab_reg list { $$ = node_new_list( $1, $2 ); debug( "RULE: list -> lab_reg list" ); }
    | lab_cmd list { $$ = node_new_list( $1, $2 ); debug( "RULE: list -> lab_cmd list" ); }
    ;

lab_con: con SEM { $$ = $1; debug( "RULE: lab_con -> con SEM" ); }
       | LABEL_CON lab_con { $$ = node_new_lab( lab_decl( $1, $2 ), $2 ); debug( "RULE: lab_con -> LABEL_CON lab_con" ); }
       ;

lab_reg: reg_cmd SEM { $$ = $1; debug( "RULE: lab_reg -> reg_cmd SEM" ); }
       | LABEL_REG lab_reg { $$ = node_new_lab( lab_decl( $1, $2 ), $2 ); debug( "RULE: lab_reg -> LABEL_REG lab_reg" ); }
       ;

lab_cmd: cmd SEM { $$ = $1; debug( "RULE: lab_cmd -> cmd SEM" ); }
       | LABEL_ADDR lab_cmd { $$ = node_new_lab( lab_decl( $1, $2 ), $2 ); debug( "RULE: lab_cmd -> LABEL_ADDR lab_cmd" ); }
       ;

reg_cmd: reg { $$ = $1; debug( "RULE: reg_cmd -> reg" ); }
       | CMD_REGISTER con { $$ = cmd_register( $2 ); debug( "RULE: reg_cmd -> CMD_REGISTER con" ); }
       | CMD_NEXT_REG { $$ = cmd_next_register( ); debug( "RULE: reg_cmd -> CMD_NEXT_REG" ); }
       ;

cmd: { $$ = cmd_empty( ); debug( "RULE: cmd ->" ); }
   | CMD_NEXT_SEC { $$ = cmd_next_sector( ); debug( "RULE: cmd -> CMD_NEXT_SEC" ); }
   | CMD_DB STRING { $$ = cmd_new_str( $2 ); debug( "RULE: cmd -> CMD_DB STRING" ); }
   | CMD_DB con { $$ = cmd_new_8b( $2 ); debug( "RULE: cmd -> CMD_DB con" ); }
   | CMD_DW con { $$ = cmd_new_16b( $2 ); debug( "RULE: cmd -> CMD_DW con" ); }
   | CMD_DD con { $$ = cmd_new_32b( $2 ); debug( "RULE: cmd -> CMD_DD con" ); }
   | CMD_JMP_NEXT_SEC { $$ = cmd_new_0( 0x00 ); debug( "RULE: cmd -> CMD_JMP_NEXT_SEC" ); }
   | CMD_JMP_SEC sec { $$ = cmd_new_8b32b_0( 0x01, $2 ); debug( "RULE: cmd -> CMD_JMP_SEC sec" ); }
   | CMD_JMP_OFS ofs { $$ = cmd_new_7b9b_0( 0x02>>1, $2 ); debug( "RULE: cmd -> CMD_JMP_OFS ofs" ); }
   | CMD_JMP_OFS_SEC addr { $$ = cmd_new_7b41b_0( 0x04>>1, $2 ); debug( "RULE: cmd -> CMD_JMP_OFS_SEC addr" ); }
   | CMD_JMP_OFS_SEC ofs COMMA sec { $$ = cmd_new_7b9b32b_0( 0x04>>1, $2, $4 ); debug( "RULE: cmd -> CMD_JMP_OFS_SEC ofs COMMA sec" ); }
   | CMD_JMP_IND reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_6( 0x06, $2, $4, $6, $8, $10, $12 ); debug( "RULE: cmd -> CMD_JMP_IND reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg" ); }
   | CMD_JMP_EQ ofs COMMA reg COMMA reg { $$ = cmd_new_7b9b_2( 0x08>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_EQ ofs COMMA reg COMMA reg" ); }
   | CMD_JMP_EQ ofs COMMA reg COMMA con { $$ = cmd_new_7b9b_2( 0x0A>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_EQ ofs COMMA reg COMMA con" ); }
   | CMD_JMP_NEQ ofs COMMA reg COMMA reg { $$ = cmd_new_7b9b_2( 0x0C>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_NEQ ofs COMMA reg COMMA reg" ); }
   | CMD_JMP_NEQ ofs COMMA reg COMMA con { $$ = cmd_new_7b9b_2( 0x0E>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_NEQ ofs COMMA reg COMMA con" ); }
   | CMD_JMP_GT ofs COMMA reg COMMA reg { $$ = cmd_new_7b9b_2( 0x10>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_GT ofs COMMA reg COMMA reg" ); }
   | CMD_JMP_GT ofs COMMA reg COMMA con { $$ = cmd_new_7b9b_2( 0x12>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_GT ofs COMMA reg COMMA con" ); }
   | CMD_JMP_NGT ofs COMMA reg COMMA reg { $$ = cmd_new_7b9b_2( 0x14>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_NGT ofs COMMA reg COMMA reg" ); }
   | CMD_JMP_NGT ofs COMMA reg COMMA con { $$ = cmd_new_7b9b_2( 0x16>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_NGT ofs COMMA reg COMMA con" ); }
   | CMD_JMP_LT ofs COMMA reg COMMA reg { $$ = cmd_new_7b9b_2( 0x18>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_LT ofs COMMA reg COMMA reg" ); }
   | CMD_JMP_LT ofs COMMA reg COMMA con { $$ = cmd_new_7b9b_2( 0x1A>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_LT ofs COMMA reg COMMA con" ); }
   | CMD_JMP_NLT ofs COMMA reg COMMA reg { $$ = cmd_new_7b9b_2( 0x1C>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_NLT ofs COMMA reg COMMA reg" ); }
   | CMD_JMP_NLT ofs COMMA reg COMMA con { $$ = cmd_new_7b9b_2( 0x1E>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_NLT ofs COMMA reg COMMA con" ); }
   | CMD_JMP_GTS ofs COMMA reg COMMA reg { $$ = cmd_new_7b9b_2( 0x20>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_GTS ofs COMMA reg COMMA reg" ); }
   | CMD_JMP_GTS ofs COMMA reg COMMA con { $$ = cmd_new_7b9b_2( 0x22>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_GTS ofs COMMA reg COMMA con" ); }
   | CMD_JMP_NGTS ofs COMMA reg COMMA reg { $$ = cmd_new_7b9b_2( 0x24>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_NGTS ofs COMMA reg COMMA reg" ); }
   | CMD_JMP_NGTS ofs COMMA reg COMMA con { $$ = cmd_new_7b9b_2( 0x26>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_NGTS ofs COMMA reg COMMA con" ); }
   | CMD_JMP_LTS ofs COMMA reg COMMA reg { $$ = cmd_new_7b9b_2( 0x28>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_LTS ofs COMMA reg COMMA reg" ); }
   | CMD_JMP_LTS ofs COMMA reg COMMA con { $$ = cmd_new_7b9b_2( 0x2A>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_LTS ofs COMMA reg COMMA con" ); }
   | CMD_JMP_NLTS ofs COMMA reg COMMA reg { $$ = cmd_new_7b9b_2( 0x2C>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_NLTS ofs COMMA reg COMMA reg" ); }
   | CMD_JMP_NLTS ofs COMMA reg COMMA con { $$ = cmd_new_7b9b_2( 0x2E>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_NLTS ofs COMMA reg COMMA con" ); }
   | CMD_JMP_AND_Z ofs COMMA reg COMMA reg { $$ = cmd_new_7b9b_2( 0x30>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_AND_Z ofs COMMA reg COMMA reg" ); }
   | CMD_JMP_AND_Z ofs COMMA reg COMMA con { $$ = cmd_new_7b9b_2( 0x32>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_AND_Z ofs COMMA reg COMMA con" ); }
   | CMD_JMP_AND_NZ ofs COMMA reg COMMA reg { $$ = cmd_new_7b9b_2( 0x34>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_AND_NZ ofs COMMA reg COMMA reg" ); }
   | CMD_JMP_AND_NZ ofs COMMA reg COMMA con { $$ = cmd_new_7b9b_2( 0x36>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_AND_NZ ofs COMMA reg COMMA con" ); }
   | CMD_JMP_OR_M ofs COMMA reg COMMA reg { $$ = cmd_new_7b9b_2( 0x38>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_OR_M ofs COMMA reg COMMA reg" ); }
   | CMD_JMP_OR_M ofs COMMA reg COMMA con { $$ = cmd_new_7b9b_2( 0x3A>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_OR_M ofs COMMA reg COMMA con" ); }
   | CMD_JMP_OR_NM ofs COMMA reg COMMA reg { $$ = cmd_new_7b9b_2( 0x3C>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_OR_NM ofs COMMA reg COMMA reg" ); }
   | CMD_JMP_OR_NM ofs COMMA reg COMMA con { $$ = cmd_new_7b9b_2( 0x3E>>1, $2, $4, $6 ); debug( "RULE: cmd -> CMD_JMP_OR_NM ofs COMMA reg COMMA con" ); }
   | CMD_MOV reg COMMA reg { $$ = cmd_new_2( 0x50, $2, $4 ); debug( "RULE: cmd -> CMD_MOV reg COMMA reg" ); }
   | CMD_MOV con COMMA reg { $$ = cmd_new_2( 0x51, $2, $4 ); debug( "RULE: cmd -> CMD_MOV con COMMA reg" ); }
   | CMD_MOV2 reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_4( 0x52, $2, $4, $6, $8 ); debug( "RULE: cmd -> CMD_MOV2 reg COMMA reg COMMA reg COMMA reg" ); }
   | CMD_MOV2 con COMMA reg COMMA con COMMA reg { $$ = cmd_new_4( 0x53, $2, $4, $6, $8 ); debug( "RULE: cmd -> CMD_MOV2 con COMMA reg COMMA con COMMA reg" ); }
   | CMD_MOV4 reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_6( 0x54, $2, $4, $6, $8, $10, $12 ); debug( "RULE: cmd -> CMD_MOV2 reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg" ); }
   | CMD_MOV4 con COMMA reg COMMA con COMMA reg COMMA con COMMA reg COMMA con COMMA reg { $$ = cmd_new_6( 0x55, $2, $4, $6, $8, $10, $12 ); debug( "RULE: cmd -> CMD_MOV2 con COMMA reg COMMA con COMMA reg COMMA con COMMA reg" ); }
   | CMD_RD_I reg COMMA reg { $$ = cmd_new_2( 0x58, $2, $4 ); debug( "RULE: cmd -> CMD_RD_I reg COMMA reg" ); }
   | CMD_WR_I reg COMMA reg { $$ = cmd_new_2( 0x59, $2, $4 ); debug( "RULE: cmd -> CMD_WR_I reg COMMA reg" ); }
   | CMD_RD_S reg COMMA reg COMMA reg { $$ = cmd_new_3( 0x5C, $2, $4, $6 ); debug( "RULE: cmd -> CMD_RD_S reg COMMA reg COMMA reg" ); }
   | CMD_RD_CF reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA con COMMA reg { $$ = cmd_new_9( 0x5D, $2, $4, $6, $8, $10, $12, $14, $16, $18 ); debug( "RULE: cmd -> CMD_RD_CF reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA con COMMA reg" ); }
   | CMD_ADD reg COMMA reg COMMA reg { $$ = cmd_new_3( 0x60, $2, $4, $6 ); debug( "RULE: cmd -> CMD_ADD reg COMMA reg COMMA reg" ); }
   | CMD_ADD con COMMA reg COMMA reg { $$ = cmd_new_3( 0x61, $2, $4, $6 ); debug( "RULE: cmd -> CMD_ADD con COMMA reg COMMA reg" ); }
   | CMD_ADDC reg COMMA reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_5( 0x62, $2, $4, $6, $8, $10 ); debug( "RULE: cmd -> CMD_ADDC reg COMMA reg COMMA reg COMMA reg" ); }
   | CMD_ADDC con COMMA reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_5( 0x63, $2, $4, $6, $8, $10 ); debug( "RULE: cmd -> CMD_ADDC con COMMA reg COMMA reg COMMA reg" ); }
   | CMD_SUB reg COMMA reg COMMA reg { $$ = cmd_new_3( 0x64, $2, $4, $6 ); debug( "RULE: cmd -> CMD_SUB reg COMMA reg COMMA reg" ); }
   | CMD_SUB con COMMA reg COMMA reg { $$ = cmd_new_3( 0x65, $2, $4, $6 ); debug( "RULE: cmd -> CMD_SUB con COMMA reg COMMA reg" ); }
   | CMD_SUBB reg COMMA reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_5( 0x66, $2, $4, $6, $8, $10 ); debug( "RULE: cmd -> CMD_SUBB reg COMMA reg COMMA reg COMMA reg" ); }
   | CMD_SUBB con COMMA reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_5( 0x67, $2, $4, $6, $8, $10 ); debug( "RULE: cmd -> CMD_SUBB con COMMA reg COMMA reg COMMA reg" ); }
   | CMD_MUL reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_4( 0x68, $2, $4, $6, $8 ); debug( "RULE: cmd -> CMD_MUL reg COMMA reg COMMA reg" ); }
   | CMD_MUL con COMMA reg COMMA reg COMMA reg { $$ = cmd_new_4( 0x69, $2, $4, $6, $8 ); debug( "RULE: cmd -> CMD_MUL con COMMA reg COMMA reg" ); }
   | CMD_MULS reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_4( 0x6A, $2, $4, $6, $8 ); debug( "RULE: cmd -> CMD_MULS reg COMMA reg COMMA reg COMMA reg" ); }
   | CMD_MULS con COMMA reg COMMA reg COMMA reg { $$ = cmd_new_4( 0x6B, $2, $4, $6, $8 ); debug( "RULE: cmd -> CMD_MULS con COMMA reg COMMA reg COMMA reg" ); }
   | CMD_DIV reg COMMA reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_5( 0x6C, $2, $4, $6, $8, $10 ); debug( "RULE: cmd -> CMD_DIV reg COMMA reg COMMA reg COMMA reg" ); }
   | CMD_DIVS reg COMMA reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_5( 0x6D, $2, $4, $6, $8, $10 ); debug( "RULE: cmd -> CMD_DIVS reg COMMA reg COMMA reg COMMA reg" ); }
   | CMD_AND reg COMMA reg COMMA reg { $$ = cmd_new_3( 0x70, $2, $4, $6 ); debug( "RULE: cmd -> CMD_ADD reg COMMA reg COMMA reg" ); }
   | CMD_AND con COMMA reg COMMA reg { $$ = cmd_new_3( 0x71, $2, $4, $6 ); debug( "RULE: cmd -> CMD_ADD con COMMA reg COMMA reg" ); }
   | CMD_OR reg COMMA reg COMMA reg { $$ = cmd_new_3( 0x72, $2, $4, $6 ); debug( "RULE: cmd -> CMD_OR reg COMMA reg COMMA reg" ); }
   | CMD_OR con COMMA reg COMMA reg { $$ = cmd_new_3( 0x73, $2, $4, $6 ); debug( "RULE: cmd -> CMD_OR con COMMA reg COMMA reg" ); }
   | CMD_XOR reg COMMA reg COMMA reg { $$ = cmd_new_3( 0x74, $2, $4, $6 ); debug( "RULE: cmd -> CMD_XOR reg COMMA reg COMMA reg" ); }
   | CMD_XOR con COMMA reg COMMA reg { $$ = cmd_new_3( 0x75, $2, $4, $6 ); debug( "RULE: cmd -> CMD_XOR con COMMA reg COMMA reg" ); }
   | CMD_SHL reg COMMA reg COMMA reg { $$ = cmd_new_3( 0x78, $2, $4, $6 ); debug( "RULE: cmd -> CMD_SHL reg COMMA reg COMMA reg" ); }
   | CMD_SHL con COMMA reg COMMA reg { $$ = cmd_new_3( 0x79, $2, $4, $6 ); debug( "RULE: cmd -> CMD_SHL con COMMA reg COMMA reg" ); }
   | CMD_SHR reg COMMA reg COMMA reg { $$ = cmd_new_3( 0x7A, $2, $4, $6 ); debug( "RULE: cmd -> CMD_SHR reg COMMA reg COMMA reg" ); }
   | CMD_SHR con COMMA reg COMMA reg { $$ = cmd_new_3( 0x7B, $2, $4, $6 ); debug( "RULE: cmd -> CMD_SHR con COMMA reg COMMA reg" ); }
   | CMD_ROL reg COMMA reg COMMA reg { $$ = cmd_new_3( 0x7C, $2, $4, $6 ); debug( "RULE: cmd -> CMD_ROL reg COMMA reg COMMA reg" ); }
   | CMD_ROL con COMMA reg COMMA reg { $$ = cmd_new_3( 0x7D, $2, $4, $6 ); debug( "RULE: cmd -> CMD_ROL con COMMA reg COMMA reg" ); }
   | CMD_ROR reg COMMA reg COMMA reg { $$ = cmd_new_3( 0x7E, $2, $4, $6 ); debug( "RULE: cmd -> CMD_ROR reg COMMA reg COMMA reg" ); }
   | CMD_ROR con COMMA reg COMMA reg { $$ = cmd_new_3( 0x7F, $2, $4, $6 ); debug( "RULE: cmd -> CMD_ROR con COMMA reg COMMA reg" ); }
   | CMD_PUSH reg { $$ = cmd_new_1( 0x80, $2 ); debug( "RULE: cmd -> CMD_PUSH reg" ); }
   | CMD_PUSH con { $$ = cmd_new_1( 0x81, $2 ); debug( "RULE: cmd -> CMD_PUSH con" ); }
   | CMD_POP reg { $$ = cmd_new_1( 0x82, $2 ); debug( "RULE: cmd -> CMD_POP reg" ); }
   | CMD_CALL addr { $$ = cmd_new_7b41b_0( 0x84>>1, $2 ); debug( "RULE: cmd -> CMD_CALL addr" ); }
   | CMD_CALL ofs COMMA sec { $$ = cmd_new_7b9b32b_0( 0x84>>1, $2, $4 ); debug( "RULE: cmd -> CMD_CALL ofs COMMA sec" ); }
   | CMD_CALL_IND reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_6( 0x86, $2, $4, $6, $8, $10, $12 ); debug( "RULE: cmd -> CMD_CALL_IND reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg" ); }
   | CMD_RET reg { $$ = cmd_new_0( 0x87 ); debug( "RULE: cmd -> CMD_RET" ); }
   | CMD_RD_PIX reg COMMA reg COMMA reg { $$ = cmd_new_3( 0x90, $2, $4, $6 ); debug( "RULE: cmd -> CMD_RD_PIX reg COMMA reg COMMA reg" ); }
   | CMD_RD_PIX con COMMA con COMMA reg { $$ = cmd_new_3( 0x91, $2, $4, $6 ); debug( "RULE: cmd -> CMD_RD_PIX con COMMA con COMMA reg" ); }
   | CMD_RD_OVP reg COMMA reg COMMA reg { $$ = cmd_new_3( 0x92, $2, $4, $6 ); debug( "RULE: cmd -> CMD_RD_OVP reg COMMA reg COMMA reg" ); }
   | CMD_RD_OVP con COMMA con COMMA reg { $$ = cmd_new_3( 0x93, $2, $4, $6 ); debug( "RULE: cmd -> CMD_RD_OVP con COMMA con COMMA reg" ); }
   | CMD_WR_PIX reg COMMA reg COMMA reg { $$ = cmd_new_3( 0x94, $2, $4, $6 ); debug( "RULE: cmd -> CMD_WR_PIX reg COMMA reg COMMA reg" ); }
   | CMD_WR_PIX con COMMA con COMMA reg { $$ = cmd_new_3( 0x95, $2, $4, $6 ); debug( "RULE: cmd -> CMD_WR_PIX con COMMA con COMMA reg" ); }
   | CMD_WR_OVP reg COMMA reg COMMA reg { $$ = cmd_new_3( 0x96, $2, $4, $6 ); debug( "RULE: cmd -> CMD_WR_OVP reg COMMA reg COMMA reg" ); }
   | CMD_WR_OVP con COMMA con COMMA reg { $$ = cmd_new_3( 0x97, $2, $4, $6 ); debug( "RULE: cmd -> CMD_WR_OVP con COMMA con COMMA reg" ); }
   | CMD_WR_PIX reg COMMA reg COMMA con { $$ = cmd_new_3( 0x98, $2, $4, $6 ); debug( "RULE: cmd -> CMD_WR_PIX reg COMMA reg COMMA con" ); }
   | CMD_WR_PIX con COMMA con COMMA con { $$ = cmd_new_3( 0x99, $2, $4, $6 ); debug( "RULE: cmd -> CMD_WR_PIX con COMMA con COMMA con" ); }
   | CMD_WR_OVP reg COMMA reg COMMA con { $$ = cmd_new_3( 0x9A, $2, $4, $6 ); debug( "RULE: cmd -> CMD_WR_OVP reg COMMA reg COMMA con" ); }
   | CMD_WR_OVP con COMMA con COMMA con { $$ = cmd_new_3( 0x9B, $2, $4, $6 ); debug( "RULE: cmd -> CMD_WR_OVP con COMMA con COMMA con" ); }
   | CMD_WR_PIX_LINE reg COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
     { $$ = cmd_new_14( 0xA0, $2, $4, $6, $8, $10, $12, $14, $16, $18, $20, $22, $24, $26, $28 ); debug( "RULE: cmd -> CMD_WR_PIX_LINE reg (COMMA con){13}" ); }
   | CMD_WR_PIX_LINE con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
     { $$ = cmd_new_14( 0xA1, $2, $4, $6, $8, $10, $12, $14, $16, $18, $20, $22, $24, $26, $28 ); debug( "RULE: cmd -> CMD_WR_PIX_LINE con (COMMA con){13}" ); }
   | CMD_WR_OVP_LINE reg COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
     { $$ = cmd_new_14( 0xA2, $2, $4, $6, $8, $10, $12, $14, $16, $18, $20, $22, $24, $26, $28 ); debug( "RULE: cmd -> CMD_WR_OVP_LINE reg (COMMA con){13}" ); }
   | CMD_WR_OVP_LINE con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
     { $$ = cmd_new_14( 0xA3, $2, $4, $6, $8, $10, $12, $14, $16, $18, $20, $22, $24, $26, $28 ); debug( "RULE: cmd -> CMD_WR_OVP_LINE con (COMMA con){13}" ); }
   | CMD_WR_PIX_QUART reg
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
     { $$ = cmd_new_66( 0xA4, $2,
                                     $4,   $6,   $8,  $10,  $12,  $14,  $16,  $18,  $20,  $22,  $24,  $26,  $28,
				    $30,  $32,  $34,  $36,  $38,  $40,  $42,  $44,  $46,  $48,  $50,  $52,  $54,
				    $56,  $58,  $60,  $62,  $64,  $66,  $68,  $70,  $72,  $74,  $76,  $78,  $80,
				    $82,  $84,  $86,  $88,  $90,  $92,  $94,  $96,  $98, $100, $102, $104, $106,
				   $108, $110, $112, $114, $116, $118, $120, $122, $124, $126, $128, $130, $132 );
       debug( "RULE: cmd -> CMD_WR_PIX_QUART reg (COMMA con){65}" ); }
   | CMD_WR_PIX_QUART con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
     { $$ = cmd_new_66( 0xA5, $2,
                                     $4,   $6,   $8,  $10,  $12,  $14,  $16,  $18,  $20,  $22,  $24,  $26,  $28,
				    $30,  $32,  $34,  $36,  $38,  $40,  $42,  $44,  $46,  $48,  $50,  $52,  $54,
				    $56,  $58,  $60,  $62,  $64,  $66,  $68,  $70,  $72,  $74,  $76,  $78,  $80,
				    $82,  $84,  $86,  $88,  $90,  $92,  $94,  $96,  $98, $100, $102, $104, $106,
				   $108, $110, $112, $114, $116, $118, $120, $122, $124, $126, $128, $130, $132 );
       debug( "RULE: cmd -> CMD_WR_PIX_QUART con (COMMA con){65}" ); }
   | CMD_WR_OVP_QUART reg
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
     { $$ = cmd_new_66( 0xA6, $2,
                                     $4,   $6,   $8,  $10,  $12,  $14,  $16,  $18,  $20,  $22,  $24,  $26,  $28,
				    $30,  $32,  $34,  $36,  $38,  $40,  $42,  $44,  $46,  $48,  $50,  $52,  $54,
				    $56,  $58,  $60,  $62,  $64,  $66,  $68,  $70,  $72,  $74,  $76,  $78,  $80,
				    $82,  $84,  $86,  $88,  $90,  $92,  $94,  $96,  $98, $100, $102, $104, $106,
				   $108, $110, $112, $114, $116, $118, $120, $122, $124, $126, $128, $130, $132 );
       debug( "RULE: cmd -> CMD_WR_OVP_QUART reg (COMMA con){65}" ); }
   | CMD_WR_OVP_QUART con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
                      COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
     { $$ = cmd_new_66( 0xA7, $2,
                                     $4,   $6,   $8,  $10,  $12,  $14,  $16,  $18,  $20,  $22,  $24,  $26,  $28,
				    $30,  $32,  $34,  $36,  $38,  $40,  $42,  $44,  $46,  $48,  $50,  $52,  $54,
				    $56,  $58,  $60,  $62,  $64,  $66,  $68,  $70,  $72,  $74,  $76,  $78,  $80,
				    $82,  $84,  $86,  $88,  $90,  $92,  $94,  $96,  $98, $100, $102, $104, $106,
				   $108, $110, $112, $114, $116, $118, $120, $122, $124, $126, $128, $130, $132 );
       debug( "RULE: cmd -> CMD_WR_OVP_QUART con (COMMA con){65}" ); }
   | CMD_WR_PIX_CLR { $$ = cmd_new_0( 0xA8 ); debug( "RULE: cmd -> CMD_WR_PIC_CLR" ); }
   | CMD_WR_OVP_CLR { $$ = cmd_new_0( 0xA9 ); debug( "RULE: cmd -> CMD_WR_OVP_CLR" ); }
   | CMD_WR_PIX_SET { $$ = cmd_new_0( 0xAA ); debug( "RULE: cmd -> CMD_WR_PIX_SET" ); }
   | CMD_WR_OVP_SET { $$ = cmd_new_0( 0xAB ); debug( "RULE: cmd -> CMD_WR_OVP_SET" ); }
   | CMD_WR_PIX_BW
                   con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                   con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                   con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                   con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                   con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
     { $$ = cmd_new_65( 0xAC,
                                     $2,  $4,   $6,   $8,  $10,  $12,  $14,  $16,  $18,  $20,  $22,  $24,  $26,
				    $28, $30,  $32,  $34,  $36,  $38,  $40,  $42,  $44,  $46,  $48,  $50,  $52,
				    $54, $56,  $58,  $60,  $62,  $64,  $66,  $68,  $70,  $72,  $74,  $76,  $78,
				    $80, $82,  $84,  $86,  $88,  $90,  $92,  $94,  $96,  $98, $100, $102, $104,
				   $106, $108, $110, $112, $114, $116, $118, $120, $122, $124, $126, $128, $130 );
       debug( "RULE: cmd -> CMD_WR_PIX_BW con (COMMA con){64}" ); }
   | CMD_WR_OVP_BW
                   con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                   con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                   con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                   con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                   con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
     { $$ = cmd_new_65( 0xAD,
                                     $2,  $4,   $6,   $8,  $10,  $12,  $14,  $16,  $18,  $20,  $22,  $24,  $26,
				    $28, $30,  $32,  $34,  $36,  $38,  $40,  $42,  $44,  $46,  $48,  $50,  $52,
				    $54, $56,  $58,  $60,  $62,  $64,  $66,  $68,  $70,  $72,  $74,  $76,  $78,
				    $80, $82,  $84,  $86,  $88,  $90,  $92,  $94,  $96,  $98, $100, $102, $104,
				   $106, $108, $110, $112, $114, $116, $118, $120, $122, $124, $126, $128, $130 );
       debug( "RULE: cmd -> CMD_WR_OVP_BW con (COMMA con){64}" ); }
   | CMD_WR_PIX_SEL reg COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
     { $$ = cmd_new_66( 0xAE, $2,
                                     $4,   $6,   $8,  $10,  $12,  $14,  $16,  $18,  $20,  $22,  $24,  $26,  $28,
				    $30,  $32,  $34,  $36,  $38,  $40,  $42,  $44,  $46,  $48,  $50,  $52,  $54,
				    $56,  $58,  $60,  $62,  $64,  $66,  $68,  $70,  $72,  $74,  $76,  $78,  $80,
				    $82,  $84,  $86,  $88,  $90,  $92,  $94,  $96,  $98, $100, $102, $104, $106,
				   $108, $110, $112, $114, $116, $118, $120, $122, $124, $126, $128, $130, $132 );
       debug( "RULE: cmd -> CMD_WR_PIX_SEL reg (COMMA con){65}" ); }
   | CMD_WR_PIX_SEL con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
     { $$ = cmd_new_66( 0xAF, $2,
                                     $4,   $6,   $8,  $10,  $12,  $14,  $16,  $18,  $20,  $22,  $24,  $26,  $28,
				    $30,  $32,  $34,  $36,  $38,  $40,  $42,  $44,  $46,  $48,  $50,  $52,  $54,
				    $56,  $58,  $60,  $62,  $64,  $66,  $68,  $70,  $72,  $74,  $76,  $78,  $80,
				    $82,  $84,  $86,  $88,  $90,  $92,  $94,  $96,  $98, $100, $102, $104, $106,
				   $108, $110, $112, $114, $116, $118, $120, $122, $124, $126, $128, $130, $132 );
       debug( "RULE: cmd -> CMD_WR_PIX_SEL con (COMMA con){65}" ); }
   | CMD_WR_OVP_SEL reg COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
     { $$ = cmd_new_66( 0xB0, $2,
                                     $4,   $6,   $8,  $10,  $12,  $14,  $16,  $18,  $20,  $22,  $24,  $26,  $28,
				    $30,  $32,  $34,  $36,  $38,  $40,  $42,  $44,  $46,  $48,  $50,  $52,  $54,
				    $56,  $58,  $60,  $62,  $64,  $66,  $68,  $70,  $72,  $74,  $76,  $78,  $80,
				    $82,  $84,  $86,  $88,  $90,  $92,  $94,  $96,  $98, $100, $102, $104, $106,
				   $108, $110, $112, $114, $116, $118, $120, $122, $124, $126, $128, $130, $132 );
       debug( "RULE: cmd -> CMD_WR_OVP_SEL reg (COMMA con){65}" ); }
   | CMD_WR_OVP_SEL con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA
                    con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con COMMA con
     { $$ = cmd_new_66( 0xB1, $2,
                                     $4,   $6,   $8,  $10,  $12,  $14,  $16,  $18,  $20,  $22,  $24,  $26,  $28,
				    $30,  $32,  $34,  $36,  $38,  $40,  $42,  $44,  $46,  $48,  $50,  $52,  $54,
				    $56,  $58,  $60,  $62,  $64,  $66,  $68,  $70,  $72,  $74,  $76,  $78,  $80,
				    $82,  $84,  $86,  $88,  $90,  $92,  $94,  $96,  $98, $100, $102, $104, $106,
				   $108, $110, $112, $114, $116, $118, $120, $122, $124, $126, $128, $130, $132 );
       debug( "RULE: cmd -> CMD_WR_OVP_SEL con (COMMA con){65}" ); }
   | CMD_CP_BLK_PP cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm
     { $$ = cmd_new_code2_6( 0xB4, 0x00 | (cp_blk_flags & 0x3F), $2, $4, $6, $8, $10, $12 );
       debug( "RULE: cmd -> CMD_CP_BLK_PP cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm" ); }
   | CMD_CP_BLK_PO cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm
     { $$ = cmd_new_code2_6( 0xB4, 0x40 | (cp_blk_flags & 0x3F), $2, $4, $6, $8, $10, $12 );
       debug( "RULE: cmd -> CMD_CP_BLK_PO cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm" ); }
   | CMD_CP_BLK_OP cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm
     { $$ = cmd_new_code2_6( 0xB4, 0x80 | (cp_blk_flags & 0x3F), $2, $4, $6, $8, $10, $12 );
       debug( "RULE: cmd -> CMD_CP_BLK_OP cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm" ); }
   | CMD_CP_BLK_OO cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm
     { $$ = cmd_new_code2_6( 0xB4, 0xC0 | (cp_blk_flags & 0x3F), $2, $4, $6, $8, $10, $12 );
       debug( "RULE: cmd -> CMD_CP_BLK_OO cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm" ); }
   | CMD_CP_BLK_PP_TR reg COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm
     { $$ = cmd_new_code2_7( 0xB6, 0x00 | (cp_blk_flags & 0x3F), $2, $4, $6, $8, $10, $12, $14 );
       debug( "RULE: cmd -> CMD_CP_BLK_PP_TR reg COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm" ); }
   | CMD_CP_BLK_PO_TR reg COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm
     { $$ = cmd_new_code2_7( 0xB6, 0x40 | (cp_blk_flags & 0x3F), $2, $4, $6, $8, $10, $12, $14 );
       debug( "RULE: cmd -> CMD_CP_BLK_PO_TR reg COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm" ); }
   | CMD_CP_BLK_OP_TR reg COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm
     { $$ = cmd_new_code2_7( 0xB6, 0x80 | (cp_blk_flags & 0x3F), $2, $4, $6, $8, $10, $12, $14 );
       debug( "RULE: cmd -> CMD_CP_BLK_OP_TR reg COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm" ); }
   | CMD_CP_BLK_OO_TR reg COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm
     { $$ = cmd_new_code2_7( 0xB6, 0xC0 | (cp_blk_flags & 0x3F), $2, $4, $6, $8, $10, $12, $14 );
       debug( "RULE: cmd -> CMD_CP_BLK_OO_TR reg COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm" ); }
   | CMD_CP_BLK_PP_TR con COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm
     { $$ = cmd_new_code2_7( 0xB7, 0x00 | (cp_blk_flags & 0x3F), $2, $4, $6, $8, $10, $12, $14 );
       debug( "RULE: cmd -> CMD_CP_BLK_PP_TR con COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm" ); }
   | CMD_CP_BLK_PO_TR con COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm
     { $$ = cmd_new_code2_7( 0xB7, 0x40 | (cp_blk_flags & 0x3F), $2, $4, $6, $8, $10, $12, $14 );
       debug( "RULE: cmd -> CMD_CP_BLK_PO_TR con COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm" ); }
   | CMD_CP_BLK_OP_TR con COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm
     { $$ = cmd_new_code2_7( 0xB7, 0x80 | (cp_blk_flags & 0x3F), $2, $4, $6, $8, $10, $12, $14 );
       debug( "RULE: cmd -> CMD_CP_BLK_OP_TR con COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm" ); }
   | CMD_CP_BLK_OO_TR con COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm
     { $$ = cmd_new_code2_7( 0xB7, 0xC0 | (cp_blk_flags & 0x3F), $2, $4, $6, $8, $10, $12, $14 );
       debug( "RULE: cmd -> CMD_CP_BLK_OO_TR con COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm COMMA cp_blk_prm" ); }
   | CMD_DISPLAY { $$ = cmd_new_0( 0xC0 ); debug( "RULE: cmd -> CMD_DISPLAY" ); }
   | CMD_DISPLAY_CP { $$ = cmd_new_0( 0xC1 ); debug( "RULE: cmd -> CMD_DISPLAY_CP" ); }
   | CMD_DELAY_DO reg COMMA reg { $$ = cmd_new_2( 0xC8, $2, $4 ); debug( "RULE: cmd -> CMD_DELAY_DO reg COMMA reg" ); }
   | CMD_DELAY_DO con { $$ = cmd_new_8b16b_0( 0xC9, $2 ); debug( "RULE: cmd -> CMD_DELAY_DO con" ); }
   | CMD_DELAY_START reg COMMA reg { $$ = cmd_new_2( 0xCA, $2, $4 ); debug( "RULE: cmd -> CMD_DELAY_START reg COMMA reg" ); }
   | CMD_DELAY_START con { $$ = cmd_new_8b16b_0( 0xCB, $2 ); debug( "RULE: cmd -> CMD_DELAY_START con" ); }
   | CMD_DELAY_CHECK reg { $$ = cmd_new_1( 0xCC, $2 ); debug( "RULE: cmd -> CMD_DELAY_CHECK reg" ); }
   | CMD_DELAY_WAIT { $$ = cmd_new_0( 0xFF ); debug( "RULE: cmd -> CMD_DELAY_WAIT" ); }
   | CMD_GET_KEYS reg COMMA reg COMMA reg { $$ = cmd_new_3( 0xD0, $2, $4, $6 ); debug( "RULE: cmd -> CMD_GET_KEYS reg COMMA reg COMMA reg" ); }
   | CMD_GET_SNES0 reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_6( 0xD2, $2, $4, $6, $8, $10, $12 ); debug( "RULE: cmd -> CMD_GET_SNES0 reg COMMA reg COMMA reg COMMa reg COMMA reg COMMA reg" ); }
   | CMD_GET_SNES1 reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_6( 0xD3, $2, $4, $6, $8, $10, $12 ); debug( "RULE: cmd -> CMD_GET_SNES1 reg COMMA reg COMMA reg COMMa reg COMMA reg COMMA reg" ); }
   | CMD_GET_TIME reg COMMA reg COMMA reg { $$ = cmd_new_3( 0xD4, $2, $4, $6 ); debug( "RULE: cmd -> CMD_GET_TIME reg COMMA reg COMMA reg" ); }
   | CMD_SET_TIME reg COMMA reg COMMA reg { $$ = cmd_new_3( 0xD5, $2, $4, $6 ); debug( "RULE: cmd -> CMD_SET_TIME reg COMMA reg COMMA reg" ); }
   | CMD_RND reg { $$ = cmd_new_1( 0xD8, $2 ); debug( "RULE: cmd -> CMD_RND reg" ); }
   | CMD_VER reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg { $$ = cmd_new_6( 0xDC, $2, $4, $6, $8, $10, $12 ); debug( "RULE: cmd -> CMD_VER reg COMMA reg COMMA reg COMMA reg COMMA reg COMMA reg" ); }
   | CMD_NOP { $$ = cmd_new_0( 0xFF ); debug( "RULE: cmd -> CMD_NOP" ); }
   | error { $$ = NULL; debug( "RULE: cmd -> error" ); }
   ;

cp_blk_prm: con { $$ = $1; cp_blk_flags = cp_blk_flags << 1 | 1; debug( "RULE: cp_blk_prm -> con" ); }
          | reg { $$ = $1; cp_blk_flags = cp_blk_flags << 1; debug( "RULE: cp_blk_prm -> reg" ); }
          ;

reg: reg_solid { $$ = $1; debug( "RULE: reg -> reg_solid" ); }
   | REG con_solid { $$ = node_new_reg_con( $2 ); debug( "RULE: reg -> REG con_solid" ); }
   | reg_solid ADD con_solid { $$ = node_new_reg_binary( '+', $1, $3 ); debug( "RULE: reg -> reg_solid ADD con_solid" ); }
   | reg_solid SUB con_solid { $$ = node_new_reg_binary( '-', $1, $3 ); debug( "RULE: reg -> reg_solid SUB con_solid" ); }
   ;

reg_solid: IDENT_REG { $$ = $1; debug( "RULE: reg_solid -> IDENT_REG" ); }
	 | LBRA reg RBRA { $$ = node_new_reg_bra( $2 ); debug( "RULE: reg_solid -> LBRA reg RBRA" ); }
	 ;

sec: con { $$ = $1; debug( "RULE: sec -> con" ); }
   | addr { $$ = node_new_sec_addr( $1 ); debug( "RULE: sec -> addr" ); }
   ;

ofs: con { $$ = $1; debug( "RULE: ofs -> con" ); }
   | addr { $$ = node_new_ofs_addr( $1, cur_addr_sec ); debug( "RULE: ofs -> addr" ); }
   ;

con: con_or { $$ = $1; debug( "RULE: con -> con_or" ); }
   | reg_solid SUB reg_solid { $$ = node_new_con_regdif( $1, $3 ); debug( "RULE: con -> reg_solid SUB reg_solid" ); }
   ;

con_or: con_xor { $$ = $1; debug( "RULE: con_or -> con_xor" ); }
      | con_or OR con_xor { $$ = node_new_con_binary( '|', $1, $3 ); debug( "RULE: con_or -> con_or OR con_xor" ); }
      ;

con_xor: con_and { $$ = $1; debug( "RULE: con_xor -> con_and" ); }
       | con_xor XOR con_and { $$ = node_new_con_binary( '^', $1, $3 ); debug( "RULE: con_xor -> con_xor XOR xon_and" ); }
       ;

con_and: con_sh { $$ = $1; debug( "RULE: con_and -> con_sh" ); }
       | con_and AND con_sh { $$ = node_new_con_binary( '&', $1, $3 ); debug( "RULE: con_and -> con_and AND con_sh" ); }
       ;

con_sh: con_add { $$ = $1; debug( "RULE: con_sh -> con_add" ); }
      | con_sh SHL con_add { $$ = node_new_con_binary( '<', $1, $3 ); debug( "RULE: con -> con_sh AHL con_add" ); }
      | con_sh SHR con_add { $$ = node_new_con_binary( '>', $1, $3 ); debug( "RULE: con_sh -> con_sh SHR con_add" ); }
      ;

con_add: con_mul { $$ = $1; debug( "RULE: con_add -> con_mul" ); }
       | con_add ADD con_mul { $$ = node_new_con_binary( '+', $1, $3 ); debug( "RULE: con_add -> con_add ADD con_mul" ); }
       | con_add SUB con_mul { $$ = node_new_con_binary( '-', $1, $3 ); debug( "RULE: con_add -> con_add SUB con_mul" ); }
       ;

con_mul: con_unary { $$ = $1; debug( "RULE: con_mul -> con_unary" ); }
       | con_mul MUL con_unary { $$ = node_new_con_binary( '*', $1, $3 ); debug( "RULE: con_mul -> con_mul MUL con_unary" ); }
       | con_mul DIV con_unary { $$ = node_new_con_binary( '/', $1, $3 ); debug( "RULE: con_mul -> con_mul DIV con_unary" ); }
       | con_mul MOD con_unary { $$ = node_new_con_binary( '%', $1, $3 ); debug( "RULE: con_mul -> con_mul MOD con_unary" ); }
       ;

con_unary: con_solid { $$ = $1; debug( "RULE: con_unary -> con_solid" ); }
         | NOT con_unary { $$ = node_new_con_unary( '~', $2 ); debug( "RULE: con_unary -> NOT con_unary" ); }
         | SUB con_unary { $$ = node_new_con_unary( '-', $2 ); debug( "RULE: con_unary -> SUB con_unary" ); }
         ;

con_solid: NUMBER { $$ = $1; debug( "RULE: con_solid -> NUMBER" ); }
         | CHAR { $$ = $1; debug( "RULE: con_solid -> CHAR" ); }
         | IDENT_CON { $$ = $1; debug( "RULE: con_solid -> IDENT_CON" ); }
         | LBRA con RBRA { $$ = node_new_con_bra( $2 ); debug( "RULE: con_solid -> LBRA con RBRA" ); }
         | addr SEC { $$ = node_new_con_sec( $1 ); debug( "RULE: con_solid -> addr SEC" ); }
         | addr OFS { $$ = node_new_con_ofs( $1 ); debug( "RULE: con_solid -> addr OFS" ); }
         ;

addr: IDENT_ADDR { $$ = $1; debug( "RULE: addr -> IDENT_ADDR" ); }
    ;

%%

//error function
int yyerror( )
{
  //print error message
  printf( "ERROR: parse error in column %lu of line %lu: \"%s\"\n", column - strlen( yytext ), line, yytext );
  error_cnt++;
  return 0;
}

//function to put the current address into a command node
//also increments the current address by the length of the command
void cmd_addr( st_node * p_cmd_node )
{
  //command does not fit into current sector
  if( cur_addr_ofs + p_cmd_node->data.cmd.len > 0x200 )
  {
    //print warning message
    printf( "WARNING: command in column %lu of line %lu does not fit into current sector, using next one\n", column, line );
    warning_cnt++;
    //set current address to start of next sector
    cur_addr_ofs = 0;
    cur_addr_sec++;
    if( cur_addr_sec == 0 ) //overflow in sector number (this is impossible, nobody will code 4 billion sectors in assembler, but who knows...)
    {
      //print error message
      printf( "ERROR: sector number overflow in column %lu of line %lu\n", column, line );
      error_cnt++;
    }
  }

  //put address into command node
  p_cmd_node->data.cmd.addr_sec = cur_addr_sec;
  p_cmd_node->data.cmd.addr_ofs = cur_addr_ofs;

  //increment current address by length of command
  cur_addr_ofs += p_cmd_node->data.cmd.len;
}

//functions to create nodes for (register-)commands
static inline st_node * cmd_register( st_node * p_con )
{
  st_node * p_node;
  p_node = node_new_reg( p_con );
  if( p_node != NULL ) //remeber new current register
    p_cur_reg = p_node;
  return p_node;
}
static inline st_node * cmd_next_register( )
{
  st_node * p_node;
  p_node = node_new_next_reg( p_cur_reg );
  if( p_node != NULL ) //remeber new current register
    p_cur_reg = p_node;
  return p_node;
}
static inline st_node * cmd_empty( )
{
  st_node * p_node;
  p_node = node_new_cmd( 0, 0 );
  if( p_node == NULL )
    return NULL;
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_next_sector( )
{
  st_node * p_node;
  p_node = node_new_cmd( 0, 0 );
  cmd_addr( p_node );
  cur_addr_ofs = 0; //set current address to start of next sector
  cur_addr_sec++;
  if( cur_addr_sec == 0 ) //overflow in sector number (this is impossible, nobody will code 4 billion sectors in assembler, but who knows...)
  {
    //print error message
    printf( "ERROR: sector number overflow in column %lu of line %lu\n", column, line );
    error_cnt++;
  }
  return p_node;
}
static inline st_node * cmd_new_0( unsigned char code )
{
  st_node * p_node;
  p_node = node_new_cmd( 1, 1 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_1( unsigned char code, st_node * p_param1 )
{
  st_node * p_node;
  p_node = node_new_cmd( 2, 2 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 8, .p_node = p_param1, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_2( unsigned char code, st_node * p_param1, st_node * p_param2 )
{
  st_node * p_node;
  p_node = node_new_cmd( 3, 3 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 8, .p_node = p_param1, .val = 0 };
  p_node->data.cmd.params[2] = (st_node_cmd_param){ .bits = 8, .p_node = p_param2, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_3( unsigned char code, st_node * p_param1, st_node * p_param2, st_node * p_param3 )
{
  st_node * p_node;
  p_node = node_new_cmd( 4, 4 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 8, .p_node = p_param1, .val = 0 };
  p_node->data.cmd.params[2] = (st_node_cmd_param){ .bits = 8, .p_node = p_param2, .val = 0 };
  p_node->data.cmd.params[3] = (st_node_cmd_param){ .bits = 8, .p_node = p_param3, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_4( unsigned char code, st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4 )
{
  st_node * p_node;
  p_node = node_new_cmd( 5, 5 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 8, .p_node = p_param1, .val = 0 };
  p_node->data.cmd.params[2] = (st_node_cmd_param){ .bits = 8, .p_node = p_param2, .val = 0 };
  p_node->data.cmd.params[3] = (st_node_cmd_param){ .bits = 8, .p_node = p_param3, .val = 0 };
  p_node->data.cmd.params[4] = (st_node_cmd_param){ .bits = 8, .p_node = p_param4, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_5( unsigned char code, st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5 )
{
  st_node * p_node;
  p_node = node_new_cmd( 6, 6 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 8, .p_node = p_param1, .val = 0 };
  p_node->data.cmd.params[2] = (st_node_cmd_param){ .bits = 8, .p_node = p_param2, .val = 0 };
  p_node->data.cmd.params[3] = (st_node_cmd_param){ .bits = 8, .p_node = p_param3, .val = 0 };
  p_node->data.cmd.params[4] = (st_node_cmd_param){ .bits = 8, .p_node = p_param4, .val = 0 };
  p_node->data.cmd.params[5] = (st_node_cmd_param){ .bits = 8, .p_node = p_param5, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_6( unsigned char code, st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5, st_node * p_param6 )
{
  st_node * p_node;
  p_node = node_new_cmd( 7, 7 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 8, .p_node = p_param1, .val = 0 };
  p_node->data.cmd.params[2] = (st_node_cmd_param){ .bits = 8, .p_node = p_param2, .val = 0 };
  p_node->data.cmd.params[3] = (st_node_cmd_param){ .bits = 8, .p_node = p_param3, .val = 0 };
  p_node->data.cmd.params[4] = (st_node_cmd_param){ .bits = 8, .p_node = p_param4, .val = 0 };
  p_node->data.cmd.params[5] = (st_node_cmd_param){ .bits = 8, .p_node = p_param5, .val = 0 };
  p_node->data.cmd.params[6] = (st_node_cmd_param){ .bits = 8, .p_node = p_param6, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_9( unsigned char code,
                                   st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5,
                                   st_node * p_param6, st_node * p_param7, st_node * p_param8, st_node * p_param9 )
{
  st_node * p_node;
  p_node = node_new_cmd( 10, 10 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 8, .p_node = p_param1, .val = 0 };
  p_node->data.cmd.params[2] = (st_node_cmd_param){ .bits = 8, .p_node = p_param2, .val = 0 };
  p_node->data.cmd.params[3] = (st_node_cmd_param){ .bits = 8, .p_node = p_param3, .val = 0 };
  p_node->data.cmd.params[4] = (st_node_cmd_param){ .bits = 8, .p_node = p_param4, .val = 0 };
  p_node->data.cmd.params[5] = (st_node_cmd_param){ .bits = 8, .p_node = p_param5, .val = 0 };
  p_node->data.cmd.params[6] = (st_node_cmd_param){ .bits = 8, .p_node = p_param6, .val = 0 };
  p_node->data.cmd.params[7] = (st_node_cmd_param){ .bits = 8, .p_node = p_param7, .val = 0 };
  p_node->data.cmd.params[8] = (st_node_cmd_param){ .bits = 8, .p_node = p_param8, .val = 0 };
  p_node->data.cmd.params[9] = (st_node_cmd_param){ .bits = 8, .p_node = p_param9, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_14( unsigned char code,
                                    st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5, st_node * p_param6, st_node * p_param7,
                                    st_node * p_param8, st_node * p_param9, st_node * p_param10, st_node * p_param11, st_node * p_param12, st_node * p_param13, st_node * p_param14 )
{
  st_node * p_node;
  p_node = node_new_cmd( 15, 15 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 8, .p_node = p_param1, .val = 0 };
  p_node->data.cmd.params[2] = (st_node_cmd_param){ .bits = 8, .p_node = p_param2, .val = 0 };
  p_node->data.cmd.params[3] = (st_node_cmd_param){ .bits = 8, .p_node = p_param3, .val = 0 };
  p_node->data.cmd.params[4] = (st_node_cmd_param){ .bits = 8, .p_node = p_param4, .val = 0 };
  p_node->data.cmd.params[5] = (st_node_cmd_param){ .bits = 8, .p_node = p_param5, .val = 0 };
  p_node->data.cmd.params[6] = (st_node_cmd_param){ .bits = 8, .p_node = p_param6, .val = 0 };
  p_node->data.cmd.params[7] = (st_node_cmd_param){ .bits = 8, .p_node = p_param7, .val = 0 };
  p_node->data.cmd.params[8] = (st_node_cmd_param){ .bits = 8, .p_node = p_param8, .val = 0 };
  p_node->data.cmd.params[9] = (st_node_cmd_param){ .bits = 8, .p_node = p_param9, .val = 0 };
  p_node->data.cmd.params[10] = (st_node_cmd_param){ .bits = 8, .p_node = p_param10, .val = 0 };
  p_node->data.cmd.params[11] = (st_node_cmd_param){ .bits = 8, .p_node = p_param11, .val = 0 };
  p_node->data.cmd.params[12] = (st_node_cmd_param){ .bits = 8, .p_node = p_param12, .val = 0 };
  p_node->data.cmd.params[13] = (st_node_cmd_param){ .bits = 8, .p_node = p_param13, .val = 0 };
  p_node->data.cmd.params[14] = (st_node_cmd_param){ .bits = 8, .p_node = p_param14, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_65( unsigned char code,
                                    st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5,
				    st_node * p_param6, st_node * p_param7, st_node * p_param8, st_node * p_param9, st_node * p_param10,
				    st_node * p_param11, st_node * p_param12, st_node * p_param13, st_node * p_param14, st_node * p_param15,
				    st_node * p_param16, st_node * p_param17, st_node * p_param18, st_node * p_param19, st_node * p_param20,
				    st_node * p_param21, st_node * p_param22, st_node * p_param23, st_node * p_param24, st_node * p_param25,
				    st_node * p_param26, st_node * p_param27, st_node * p_param28, st_node * p_param29, st_node * p_param30,
				    st_node * p_param31, st_node * p_param32, st_node * p_param33, st_node * p_param34, st_node * p_param35,
				    st_node * p_param36, st_node * p_param37, st_node * p_param38, st_node * p_param39, st_node * p_param40,
				    st_node * p_param41, st_node * p_param42, st_node * p_param43, st_node * p_param44, st_node * p_param45,
				    st_node * p_param46, st_node * p_param47, st_node * p_param48, st_node * p_param49, st_node * p_param50,
				    st_node * p_param51, st_node * p_param52, st_node * p_param53, st_node * p_param54, st_node * p_param55,
				    st_node * p_param56, st_node * p_param57, st_node * p_param58, st_node * p_param59, st_node * p_param60,
				    st_node * p_param61, st_node * p_param62, st_node * p_param63, st_node * p_param64, st_node * p_param65 )
{
  st_node * p_node;
  p_node = node_new_cmd( 66, 66 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 8, .p_node = p_param1, .val = 0 };
  p_node->data.cmd.params[2] = (st_node_cmd_param){ .bits = 8, .p_node = p_param2, .val = 0 };
  p_node->data.cmd.params[3] = (st_node_cmd_param){ .bits = 8, .p_node = p_param3, .val = 0 };
  p_node->data.cmd.params[4] = (st_node_cmd_param){ .bits = 8, .p_node = p_param4, .val = 0 };
  p_node->data.cmd.params[5] = (st_node_cmd_param){ .bits = 8, .p_node = p_param5, .val = 0 };
  p_node->data.cmd.params[6] = (st_node_cmd_param){ .bits = 8, .p_node = p_param6, .val = 0 };
  p_node->data.cmd.params[7] = (st_node_cmd_param){ .bits = 8, .p_node = p_param7, .val = 0 };
  p_node->data.cmd.params[8] = (st_node_cmd_param){ .bits = 8, .p_node = p_param8, .val = 0 };
  p_node->data.cmd.params[9] = (st_node_cmd_param){ .bits = 8, .p_node = p_param9, .val = 0 };
  p_node->data.cmd.params[10] = (st_node_cmd_param){ .bits = 8, .p_node = p_param10, .val = 0 };
  p_node->data.cmd.params[11] = (st_node_cmd_param){ .bits = 8, .p_node = p_param11, .val = 0 };
  p_node->data.cmd.params[12] = (st_node_cmd_param){ .bits = 8, .p_node = p_param12, .val = 0 };
  p_node->data.cmd.params[13] = (st_node_cmd_param){ .bits = 8, .p_node = p_param13, .val = 0 };
  p_node->data.cmd.params[14] = (st_node_cmd_param){ .bits = 8, .p_node = p_param14, .val = 0 };
  p_node->data.cmd.params[15] = (st_node_cmd_param){ .bits = 8, .p_node = p_param15, .val = 0 };
  p_node->data.cmd.params[16] = (st_node_cmd_param){ .bits = 8, .p_node = p_param16, .val = 0 };
  p_node->data.cmd.params[17] = (st_node_cmd_param){ .bits = 8, .p_node = p_param17, .val = 0 };
  p_node->data.cmd.params[18] = (st_node_cmd_param){ .bits = 8, .p_node = p_param18, .val = 0 };
  p_node->data.cmd.params[19] = (st_node_cmd_param){ .bits = 8, .p_node = p_param19, .val = 0 };
  p_node->data.cmd.params[20] = (st_node_cmd_param){ .bits = 8, .p_node = p_param20, .val = 0 };
  p_node->data.cmd.params[21] = (st_node_cmd_param){ .bits = 8, .p_node = p_param21, .val = 0 };
  p_node->data.cmd.params[22] = (st_node_cmd_param){ .bits = 8, .p_node = p_param22, .val = 0 };
  p_node->data.cmd.params[23] = (st_node_cmd_param){ .bits = 8, .p_node = p_param23, .val = 0 };
  p_node->data.cmd.params[24] = (st_node_cmd_param){ .bits = 8, .p_node = p_param24, .val = 0 };
  p_node->data.cmd.params[25] = (st_node_cmd_param){ .bits = 8, .p_node = p_param25, .val = 0 };
  p_node->data.cmd.params[26] = (st_node_cmd_param){ .bits = 8, .p_node = p_param26, .val = 0 };
  p_node->data.cmd.params[27] = (st_node_cmd_param){ .bits = 8, .p_node = p_param27, .val = 0 };
  p_node->data.cmd.params[28] = (st_node_cmd_param){ .bits = 8, .p_node = p_param28, .val = 0 };
  p_node->data.cmd.params[29] = (st_node_cmd_param){ .bits = 8, .p_node = p_param29, .val = 0 };
  p_node->data.cmd.params[30] = (st_node_cmd_param){ .bits = 8, .p_node = p_param30, .val = 0 };
  p_node->data.cmd.params[31] = (st_node_cmd_param){ .bits = 8, .p_node = p_param31, .val = 0 };
  p_node->data.cmd.params[32] = (st_node_cmd_param){ .bits = 8, .p_node = p_param32, .val = 0 };
  p_node->data.cmd.params[33] = (st_node_cmd_param){ .bits = 8, .p_node = p_param33, .val = 0 };
  p_node->data.cmd.params[34] = (st_node_cmd_param){ .bits = 8, .p_node = p_param34, .val = 0 };
  p_node->data.cmd.params[35] = (st_node_cmd_param){ .bits = 8, .p_node = p_param35, .val = 0 };
  p_node->data.cmd.params[36] = (st_node_cmd_param){ .bits = 8, .p_node = p_param36, .val = 0 };
  p_node->data.cmd.params[37] = (st_node_cmd_param){ .bits = 8, .p_node = p_param37, .val = 0 };
  p_node->data.cmd.params[38] = (st_node_cmd_param){ .bits = 8, .p_node = p_param38, .val = 0 };
  p_node->data.cmd.params[39] = (st_node_cmd_param){ .bits = 8, .p_node = p_param39, .val = 0 };
  p_node->data.cmd.params[40] = (st_node_cmd_param){ .bits = 8, .p_node = p_param40, .val = 0 };
  p_node->data.cmd.params[41] = (st_node_cmd_param){ .bits = 8, .p_node = p_param41, .val = 0 };
  p_node->data.cmd.params[42] = (st_node_cmd_param){ .bits = 8, .p_node = p_param42, .val = 0 };
  p_node->data.cmd.params[43] = (st_node_cmd_param){ .bits = 8, .p_node = p_param43, .val = 0 };
  p_node->data.cmd.params[44] = (st_node_cmd_param){ .bits = 8, .p_node = p_param44, .val = 0 };
  p_node->data.cmd.params[45] = (st_node_cmd_param){ .bits = 8, .p_node = p_param45, .val = 0 };
  p_node->data.cmd.params[46] = (st_node_cmd_param){ .bits = 8, .p_node = p_param46, .val = 0 };
  p_node->data.cmd.params[47] = (st_node_cmd_param){ .bits = 8, .p_node = p_param47, .val = 0 };
  p_node->data.cmd.params[48] = (st_node_cmd_param){ .bits = 8, .p_node = p_param48, .val = 0 };
  p_node->data.cmd.params[49] = (st_node_cmd_param){ .bits = 8, .p_node = p_param49, .val = 0 };
  p_node->data.cmd.params[50] = (st_node_cmd_param){ .bits = 8, .p_node = p_param50, .val = 0 };
  p_node->data.cmd.params[51] = (st_node_cmd_param){ .bits = 8, .p_node = p_param51, .val = 0 };
  p_node->data.cmd.params[52] = (st_node_cmd_param){ .bits = 8, .p_node = p_param52, .val = 0 };
  p_node->data.cmd.params[53] = (st_node_cmd_param){ .bits = 8, .p_node = p_param53, .val = 0 };
  p_node->data.cmd.params[54] = (st_node_cmd_param){ .bits = 8, .p_node = p_param54, .val = 0 };
  p_node->data.cmd.params[55] = (st_node_cmd_param){ .bits = 8, .p_node = p_param55, .val = 0 };
  p_node->data.cmd.params[56] = (st_node_cmd_param){ .bits = 8, .p_node = p_param56, .val = 0 };
  p_node->data.cmd.params[57] = (st_node_cmd_param){ .bits = 8, .p_node = p_param57, .val = 0 };
  p_node->data.cmd.params[58] = (st_node_cmd_param){ .bits = 8, .p_node = p_param58, .val = 0 };
  p_node->data.cmd.params[59] = (st_node_cmd_param){ .bits = 8, .p_node = p_param59, .val = 0 };
  p_node->data.cmd.params[60] = (st_node_cmd_param){ .bits = 8, .p_node = p_param60, .val = 0 };
  p_node->data.cmd.params[61] = (st_node_cmd_param){ .bits = 8, .p_node = p_param61, .val = 0 };
  p_node->data.cmd.params[62] = (st_node_cmd_param){ .bits = 8, .p_node = p_param62, .val = 0 };
  p_node->data.cmd.params[63] = (st_node_cmd_param){ .bits = 8, .p_node = p_param63, .val = 0 };
  p_node->data.cmd.params[64] = (st_node_cmd_param){ .bits = 8, .p_node = p_param64, .val = 0 };
  p_node->data.cmd.params[65] = (st_node_cmd_param){ .bits = 8, .p_node = p_param65, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_66( unsigned char code,
                                    st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5,
				    st_node * p_param6, st_node * p_param7, st_node * p_param8, st_node * p_param9, st_node * p_param10,
				    st_node * p_param11, st_node * p_param12, st_node * p_param13, st_node * p_param14, st_node * p_param15,
				    st_node * p_param16, st_node * p_param17, st_node * p_param18, st_node * p_param19, st_node * p_param20,
				    st_node * p_param21, st_node * p_param22, st_node * p_param23, st_node * p_param24, st_node * p_param25,
				    st_node * p_param26, st_node * p_param27, st_node * p_param28, st_node * p_param29, st_node * p_param30,
				    st_node * p_param31, st_node * p_param32, st_node * p_param33, st_node * p_param34, st_node * p_param35,
				    st_node * p_param36, st_node * p_param37, st_node * p_param38, st_node * p_param39, st_node * p_param40,
				    st_node * p_param41, st_node * p_param42, st_node * p_param43, st_node * p_param44, st_node * p_param45,
				    st_node * p_param46, st_node * p_param47, st_node * p_param48, st_node * p_param49, st_node * p_param50,
				    st_node * p_param51, st_node * p_param52, st_node * p_param53, st_node * p_param54, st_node * p_param55,
				    st_node * p_param56, st_node * p_param57, st_node * p_param58, st_node * p_param59, st_node * p_param60,
				    st_node * p_param61, st_node * p_param62, st_node * p_param63, st_node * p_param64, st_node * p_param65,
				    st_node * p_param66 )
{
  st_node * p_node;
  p_node = node_new_cmd( 67, 67 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 8, .p_node = p_param1, .val = 0 };
  p_node->data.cmd.params[2] = (st_node_cmd_param){ .bits = 8, .p_node = p_param2, .val = 0 };
  p_node->data.cmd.params[3] = (st_node_cmd_param){ .bits = 8, .p_node = p_param3, .val = 0 };
  p_node->data.cmd.params[4] = (st_node_cmd_param){ .bits = 8, .p_node = p_param4, .val = 0 };
  p_node->data.cmd.params[5] = (st_node_cmd_param){ .bits = 8, .p_node = p_param5, .val = 0 };
  p_node->data.cmd.params[6] = (st_node_cmd_param){ .bits = 8, .p_node = p_param6, .val = 0 };
  p_node->data.cmd.params[7] = (st_node_cmd_param){ .bits = 8, .p_node = p_param7, .val = 0 };
  p_node->data.cmd.params[8] = (st_node_cmd_param){ .bits = 8, .p_node = p_param8, .val = 0 };
  p_node->data.cmd.params[9] = (st_node_cmd_param){ .bits = 8, .p_node = p_param9, .val = 0 };
  p_node->data.cmd.params[10] = (st_node_cmd_param){ .bits = 8, .p_node = p_param10, .val = 0 };
  p_node->data.cmd.params[11] = (st_node_cmd_param){ .bits = 8, .p_node = p_param11, .val = 0 };
  p_node->data.cmd.params[12] = (st_node_cmd_param){ .bits = 8, .p_node = p_param12, .val = 0 };
  p_node->data.cmd.params[13] = (st_node_cmd_param){ .bits = 8, .p_node = p_param13, .val = 0 };
  p_node->data.cmd.params[14] = (st_node_cmd_param){ .bits = 8, .p_node = p_param14, .val = 0 };
  p_node->data.cmd.params[15] = (st_node_cmd_param){ .bits = 8, .p_node = p_param15, .val = 0 };
  p_node->data.cmd.params[16] = (st_node_cmd_param){ .bits = 8, .p_node = p_param16, .val = 0 };
  p_node->data.cmd.params[17] = (st_node_cmd_param){ .bits = 8, .p_node = p_param17, .val = 0 };
  p_node->data.cmd.params[18] = (st_node_cmd_param){ .bits = 8, .p_node = p_param18, .val = 0 };
  p_node->data.cmd.params[19] = (st_node_cmd_param){ .bits = 8, .p_node = p_param19, .val = 0 };
  p_node->data.cmd.params[20] = (st_node_cmd_param){ .bits = 8, .p_node = p_param20, .val = 0 };
  p_node->data.cmd.params[21] = (st_node_cmd_param){ .bits = 8, .p_node = p_param21, .val = 0 };
  p_node->data.cmd.params[22] = (st_node_cmd_param){ .bits = 8, .p_node = p_param22, .val = 0 };
  p_node->data.cmd.params[23] = (st_node_cmd_param){ .bits = 8, .p_node = p_param23, .val = 0 };
  p_node->data.cmd.params[24] = (st_node_cmd_param){ .bits = 8, .p_node = p_param24, .val = 0 };
  p_node->data.cmd.params[25] = (st_node_cmd_param){ .bits = 8, .p_node = p_param25, .val = 0 };
  p_node->data.cmd.params[26] = (st_node_cmd_param){ .bits = 8, .p_node = p_param26, .val = 0 };
  p_node->data.cmd.params[27] = (st_node_cmd_param){ .bits = 8, .p_node = p_param27, .val = 0 };
  p_node->data.cmd.params[28] = (st_node_cmd_param){ .bits = 8, .p_node = p_param28, .val = 0 };
  p_node->data.cmd.params[29] = (st_node_cmd_param){ .bits = 8, .p_node = p_param29, .val = 0 };
  p_node->data.cmd.params[30] = (st_node_cmd_param){ .bits = 8, .p_node = p_param30, .val = 0 };
  p_node->data.cmd.params[31] = (st_node_cmd_param){ .bits = 8, .p_node = p_param31, .val = 0 };
  p_node->data.cmd.params[32] = (st_node_cmd_param){ .bits = 8, .p_node = p_param32, .val = 0 };
  p_node->data.cmd.params[33] = (st_node_cmd_param){ .bits = 8, .p_node = p_param33, .val = 0 };
  p_node->data.cmd.params[34] = (st_node_cmd_param){ .bits = 8, .p_node = p_param34, .val = 0 };
  p_node->data.cmd.params[35] = (st_node_cmd_param){ .bits = 8, .p_node = p_param35, .val = 0 };
  p_node->data.cmd.params[36] = (st_node_cmd_param){ .bits = 8, .p_node = p_param36, .val = 0 };
  p_node->data.cmd.params[37] = (st_node_cmd_param){ .bits = 8, .p_node = p_param37, .val = 0 };
  p_node->data.cmd.params[38] = (st_node_cmd_param){ .bits = 8, .p_node = p_param38, .val = 0 };
  p_node->data.cmd.params[39] = (st_node_cmd_param){ .bits = 8, .p_node = p_param39, .val = 0 };
  p_node->data.cmd.params[40] = (st_node_cmd_param){ .bits = 8, .p_node = p_param40, .val = 0 };
  p_node->data.cmd.params[41] = (st_node_cmd_param){ .bits = 8, .p_node = p_param41, .val = 0 };
  p_node->data.cmd.params[42] = (st_node_cmd_param){ .bits = 8, .p_node = p_param42, .val = 0 };
  p_node->data.cmd.params[43] = (st_node_cmd_param){ .bits = 8, .p_node = p_param43, .val = 0 };
  p_node->data.cmd.params[44] = (st_node_cmd_param){ .bits = 8, .p_node = p_param44, .val = 0 };
  p_node->data.cmd.params[45] = (st_node_cmd_param){ .bits = 8, .p_node = p_param45, .val = 0 };
  p_node->data.cmd.params[46] = (st_node_cmd_param){ .bits = 8, .p_node = p_param46, .val = 0 };
  p_node->data.cmd.params[47] = (st_node_cmd_param){ .bits = 8, .p_node = p_param47, .val = 0 };
  p_node->data.cmd.params[48] = (st_node_cmd_param){ .bits = 8, .p_node = p_param48, .val = 0 };
  p_node->data.cmd.params[49] = (st_node_cmd_param){ .bits = 8, .p_node = p_param49, .val = 0 };
  p_node->data.cmd.params[50] = (st_node_cmd_param){ .bits = 8, .p_node = p_param50, .val = 0 };
  p_node->data.cmd.params[51] = (st_node_cmd_param){ .bits = 8, .p_node = p_param51, .val = 0 };
  p_node->data.cmd.params[52] = (st_node_cmd_param){ .bits = 8, .p_node = p_param52, .val = 0 };
  p_node->data.cmd.params[53] = (st_node_cmd_param){ .bits = 8, .p_node = p_param53, .val = 0 };
  p_node->data.cmd.params[54] = (st_node_cmd_param){ .bits = 8, .p_node = p_param54, .val = 0 };
  p_node->data.cmd.params[55] = (st_node_cmd_param){ .bits = 8, .p_node = p_param55, .val = 0 };
  p_node->data.cmd.params[56] = (st_node_cmd_param){ .bits = 8, .p_node = p_param56, .val = 0 };
  p_node->data.cmd.params[57] = (st_node_cmd_param){ .bits = 8, .p_node = p_param57, .val = 0 };
  p_node->data.cmd.params[58] = (st_node_cmd_param){ .bits = 8, .p_node = p_param58, .val = 0 };
  p_node->data.cmd.params[59] = (st_node_cmd_param){ .bits = 8, .p_node = p_param59, .val = 0 };
  p_node->data.cmd.params[60] = (st_node_cmd_param){ .bits = 8, .p_node = p_param60, .val = 0 };
  p_node->data.cmd.params[61] = (st_node_cmd_param){ .bits = 8, .p_node = p_param61, .val = 0 };
  p_node->data.cmd.params[62] = (st_node_cmd_param){ .bits = 8, .p_node = p_param62, .val = 0 };
  p_node->data.cmd.params[63] = (st_node_cmd_param){ .bits = 8, .p_node = p_param63, .val = 0 };
  p_node->data.cmd.params[64] = (st_node_cmd_param){ .bits = 8, .p_node = p_param64, .val = 0 };
  p_node->data.cmd.params[65] = (st_node_cmd_param){ .bits = 8, .p_node = p_param65, .val = 0 };
  p_node->data.cmd.params[66] = (st_node_cmd_param){ .bits = 8, .p_node = p_param66, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_7b9b_0( unsigned char code7b, st_node * p_param9b )
{
  st_node * p_node;
  p_node = node_new_cmd( 2, 2 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 7, .p_node = NULL, .val = code7b };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 9, .p_node = p_param9b, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_7b9b_2( unsigned char code7b, st_node * p_param9b, st_node * p_param1, st_node * p_param2 )
{
  st_node * p_node;
  p_node = node_new_cmd( 4, 4 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 7, .p_node = NULL, .val = code7b };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 9, .p_node = p_param9b, .val = 0 };
  p_node->data.cmd.params[2] = (st_node_cmd_param){ .bits = 8, .p_node = p_param1, .val = 0 };
  p_node->data.cmd.params[3] = (st_node_cmd_param){ .bits = 8, .p_node = p_param2, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_8b16b_0( unsigned char code8b, st_node * p_param16b )
{
  st_node * p_node;
  p_node = node_new_cmd( 2, 3 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code8b };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 16, .p_node = p_param16b, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_8b32b_0( unsigned char code8b, st_node * p_param32b )
{
  st_node * p_node;
  p_node = node_new_cmd( 2, 5 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code8b };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 32, .p_node = p_param32b, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_7b9b32b_0( unsigned char code7b, st_node * p_param9b, st_node * p_param32b )
{
  st_node * p_node;
  p_node = node_new_cmd( 3, 6 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 7, .p_node = NULL, .val = code7b };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 9, .p_node = p_param9b, .val = 0 };
  p_node->data.cmd.params[2] = (st_node_cmd_param){ .bits = 32, .p_node = p_param32b, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_7b41b_0( unsigned char code7b, st_node * p_param41b )
{
  st_node * p_node;
  p_node = node_new_cmd( 2, 6 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 7, .p_node = NULL, .val = code7b };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 41, .p_node = p_param41b, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_code2_6( unsigned char code, unsigned char code2, st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5, st_node * p_param6 )
{
  st_node * p_node;
  p_node = node_new_cmd( 8, 8 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code2 };
  p_node->data.cmd.params[2] = (st_node_cmd_param){ .bits = 8, .p_node = p_param1, .val = 0 };
  p_node->data.cmd.params[3] = (st_node_cmd_param){ .bits = 8, .p_node = p_param2, .val = 0 };
  p_node->data.cmd.params[4] = (st_node_cmd_param){ .bits = 8, .p_node = p_param3, .val = 0 };
  p_node->data.cmd.params[5] = (st_node_cmd_param){ .bits = 8, .p_node = p_param4, .val = 0 };
  p_node->data.cmd.params[6] = (st_node_cmd_param){ .bits = 8, .p_node = p_param5, .val = 0 };
  p_node->data.cmd.params[7] = (st_node_cmd_param){ .bits = 8, .p_node = p_param6, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_code2_7( unsigned char code, unsigned char code2, st_node * p_param1, st_node * p_param2, st_node * p_param3, st_node * p_param4, st_node * p_param5, st_node * p_param6, st_node * p_param7 )
{
  st_node * p_node;
  p_node = node_new_cmd( 9, 9 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code };
  p_node->data.cmd.params[1] = (st_node_cmd_param){ .bits = 8, .p_node = NULL, .val = code2 };
  p_node->data.cmd.params[2] = (st_node_cmd_param){ .bits = 8, .p_node = p_param1, .val = 0 };
  p_node->data.cmd.params[3] = (st_node_cmd_param){ .bits = 8, .p_node = p_param2, .val = 0 };
  p_node->data.cmd.params[4] = (st_node_cmd_param){ .bits = 8, .p_node = p_param3, .val = 0 };
  p_node->data.cmd.params[5] = (st_node_cmd_param){ .bits = 8, .p_node = p_param4, .val = 0 };
  p_node->data.cmd.params[6] = (st_node_cmd_param){ .bits = 8, .p_node = p_param5, .val = 0 };
  p_node->data.cmd.params[7] = (st_node_cmd_param){ .bits = 8, .p_node = p_param6, .val = 0 };
  p_node->data.cmd.params[8] = (st_node_cmd_param){ .bits = 8, .p_node = p_param7, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_8b( st_node * p_param8b )
{
  st_node * p_node;
  p_node = node_new_cmd( 1, 1 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 8, .p_node = p_param8b, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_16b( st_node * p_param16b )
{
  st_node * p_node;
  p_node = node_new_cmd( 1, 2 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 16, .p_node = p_param16b, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_32b( st_node * p_param32b )
{
  st_node * p_node;
  p_node = node_new_cmd( 1, 4 );
  if( p_node == NULL )
    return NULL;
  p_node->data.cmd.params[0] = (st_node_cmd_param){ .bits = 32, .p_node = p_param32b, .val = 0 };
  cmd_addr( p_node );
  return p_node;
}
static inline st_node * cmd_new_str( st_node * p_str )
{
  st_node * p_node;
  unsigned int i;
  if( p_str == NULL || p_str->type != node_str )
    return NULL;
  p_node = node_new_cmd( 0, p_str->data.str.len );
  if( p_node == NULL )
    return NULL;
  cmd_addr( p_node );
  for( i = 0; i < p_str->data.str.len; i++ )
    p_node->data.cmd.data[i] = p_str->data.str.data[i];
  p_node->data.cmd.data_ok = 1;
  return p_node;
}

//put pointer to declaration node into id_list
static inline st_id_list_entry * lab_decl( st_node * p_lab_node, st_node * p_decl_node )
{
  st_id_list_entry * p_lab_id;

  //get pointer to id_list entry
  switch( p_lab_node->type )
  {
    case node_con_ident: p_lab_id = p_lab_node->data.con_ident.p_id; break;
    case node_reg_ident: p_lab_id = p_lab_node->data.reg_ident.p_id; break;
    case node_addr_ident: p_lab_id = p_lab_node->data.addr_ident.p_id; break;
    default: return NULL; //unknown node type -> do nothing
  }

  //set pointer to declaration node
  p_lab_id->p_decl_node = p_decl_node;

  //return pointer to label in id list
  return p_lab_id;
}

